{% extends 'en/en_base.html' %}
{% load static %}

{% block content %}
    <section>
        <div class="bg-blue">
            <img class="jumbotron-cover" src="{% static 'images/common/jumbotron.png' %}" alt=""/>
        </div>
        <div class="spacer bg-blue scroll-up">
            <h2 class="h2 fw-100 c-white text-center mb-5">
                Map
            </h2>
            <div id="map" class="map-expand"></div>
            <div class="my-3"></div>
            <div class="map-panel">
                <form>
                    <div class="accordion" id="accordion-legend">
                        <div class="accordion-item">
                            <h2 class="accordion-header" id="legend-heading-1">
                                <button class="accordion-button" type="button" data-bs-toggle="collapse"
                                        data-bs-target="#legend-collapse-1" aria-expanded="false"
                                        aria-controls="legend-collapse-1">
                                    Category
                                </button>
                            </h2>
                            <div id="legend-collapse-1" class="accordion-collapse collapse show"
                                 aria-labelledby="legend-heading-1" data-bs-parent="#accordion-legend">
                                <div class="accordion-body">
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" name="category"
                                               value="shark" checked>
                                        <label class="form-check-label">
                                            Shark
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" name="category" value="ray"
                                               checked>
                                        <label class="form-check-label">
                                            Ray & Skates
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" name="category"
                                               value="chimaera" checked>
                                        <label class="form-check-label">
                                            Chimaera
                                        </label>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="accordion-item">
                            <h2 class="accordion-header" id="legend-heading-2">
                                <button class="accordion-button collapsed" type="button"
                                        data-bs-toggle="collapse"
                                        data-bs-target="#legend-collapse-2" aria-expanded="false"
                                        aria-controls="legend-collapse-2">
                                    Data Type
                                </button>
                            </h2>
                            <div id="legend-collapse-2" class="accordion-collapse collapse"
                                 aria-labelledby="legend-heading-2">
                                <div class="accordion-body">
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" name="type"
                                               value="sighting" checked>
                                        <label class="form-check-label">
                                            Sighting
                                        </label>
                                    </div>
                                    <div class="form-check">
                                        <input class="form-check-input" type="checkbox" name="type" value="landing"
                                               checked>
                                        <label class="form-check-label">
                                            Landing
                                        </label>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="accordion-item">
                            <h2 class="accordion-header" id="legend-heading-3">
                                <button class="accordion-button collapsed" type="button"
                                        data-bs-toggle="collapse"
                                        data-bs-target="#legend-collapse-3" aria-expanded="false"
                                        aria-controls="legend-collapse-3">
                                    Years
                                </button>
                            </h2>
                            <div id="legend-collapse-3" class="accordion-collapse collapse"
                                 aria-labelledby="legend-heading-3">
                                <div class="accordion-body">
                                    <div class="row">
                                        {% for year in years %}
                                            <div class="col-xs-12 col-lg-6">
                                                <div class="form-check">
                                                    <input class="form-check-input" type="checkbox" name="year"
                                                           value="{{ year }}" checked>
                                                    <label class="form-check-label" for="">
                                                        {{ year }}
                                                    </label>
                                                </div>
                                            </div>
                                        {% endfor %}
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </section>
    <section>
        <div class="spacer">
            <div class="d-flex justify-content-between mb-5">
                <h3 class="h3 c-blue">
                    Photo Gallery
                </h3>
                <a href="{% url 'frontend:search' %}" class="btn label bg-lightblue-2 c-white">
                    See More <i class="bi bi-card-image"></i>
                </a>
            </div>
            <div class="row justify-content-around mb-50">
                {% for g in gallery %}
                    <div class="col-xs-12 col-md-6 col-lg-4 mb-3">
                        <!-- Revision Mon 12 Sep
                            <!<a href="{{ g.image.url }}"
                               data-gallery="gallery" data-toggle="lightbox" data-caption="{{ g.thumbnail|default:"" }}">
                                <img class="rounded gallery-image" src="{{ g.image.url }}"/>
                            </a>
                        -->
                        <a href="{% url 'frontend:contributor_observation' g.observation.pk %}">
                            <img class="rounded gallery-image" src="{{ g.image.url }}"/>
                        </a>
                    </div>
                {% endfor %}
            </div>
            <div>
                <h3 class="h3 c-blue">Explore More</h3>
                <p>Search through our database for specific species and locations</p>
                <form action="{% url 'backend:search' %}" method="post">
                    {% csrf_token %}
                    <div class="row g-3">
                        <div class="col-6">
                            <input type="text" class="form-control" name="query" id="query" placeholder="Search"/>
                        </div>
                        <div class="col-3">
                            <button type="submit" class="btn btn-primary btn-sm bg-blue p-2">Search</button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </section>
    <section>
        <div class="diagonal-left bg-blue"></div>
        <div class="spacer bg-blue">
            <p class="btn label bg-yellow c-white">
                <i class="bi bi-clipboard-data"></i> Data Report
            </p>
            <div class="row text-center">
                <div class="col-xs-12 col-lg-6">
                    <div class="jumbo fw-600 c-white" data-encounter="{{ encounter_count }}" id="encounterCount">0</div>
                    <div class="h3 fw-600 c-white">Encounters Reported</div>
                </div>
                <div class="col-xs-12 col-lg-6">
                    <div class="mb-lg-5">
                        <div class="h1 fw-600 c-white" data-species="{{ species_count }}" id="speciesCount">0</div>
                        <div class="h3 fw-600 c-white">Species Found</div>
                    </div>
                    <div>
                        <div class="h1 fw-600 c-white" data-province="{{ province_count }}" id="provinceCount">0</div>
                        <div class="h3 fw-600 c-white">Provinces</div>
                    </div>
                </div>
            </div>
        </div>
    </section>
{% endblock %}

{% block js %}
    <script type="text/javascript">
        let tiles = L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            maxZoom: 18,
            attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
        });

        let latlng = L.latLng(-6.3, 106.75);
        let map = L.map('map', {center: latlng, zoom: 5, layers: [tiles]});
        let markers = L.markerClusterGroup({animateAddingMarkers: true});

        fetchData();
        map.addLayer(markers);

        $('form').on('change', 'input', function () {
            let params = $('form').serialize();
            fetchData(params);
        });

        function fetchData(params) {
            $.ajax({
                url: !!params ? `/api/maps?${params}` : '/api/maps',
                type: 'get',
                dataType: 'json',
                success: function (data) {
                    markers.clearLayers();
                    populate(data);
                }
            });
        }

        function populate(data) {
            for (let i = 0; i < data.length; i++) {
                let d = data[i];

                let pk = d['pk'];
                let obs = d['fields'];

                let category = obs['category'];
                let latitude = obs['latitude'];
                let longitude = obs['longitude'];

                if (!latitude || !longitude) continue;

                let content = generateContent(pk, obs);
                let icon = generateIcon(category);

                let marker = L.marker(L.latLng(latitude, longitude), {icon: icon});
                marker.bindPopup(content).openPopup();

                markers.addLayer(marker);
            }
        }

        function generateContent(pk, data) {
            let common_name = !!data['common_name'] ? data['common_name'] : 'Unidentified';
            let scientific_name = !!data['scientific_name'] ? data['scientific_name'] : 'Unidentified';
            let image = !!data['image'] ? data['image'] : '/static/images/common/no-image.jpeg';

            return `
                <a href="/contributor/observation/${pk}/" class="no-link">
                    <div class='container c-blue'>
                        <div class="text-center">
                            <b>${common_name}</b> <br/>
                            (<i>${scientific_name}</i>)
                        </div>
                        <div class="my-3">
                            <img src="${image}" class="d-block mx-auto maps-image" />
                        </div>
                        <p class="text-center">
                            Seen in ${data['location']}, ${data['province']}
                        </p>
                    </div>
                </a>
            `;
        }

        function generateIcon(category) {
            let color = {
                'shark': 'green',
                'ray': 'red',
                'chimaera': 'violet'
            }

            return new L.Icon({
                iconUrl: `https://raw.githubusercontent.com/pointhi/leaflet-color-markers/master/img/marker-icon-2x-${color[category]}.png`,
                shadowUrl: 'https://cdnjs.cloudflare.com/ajax/libs/leaflet/0.7.7/images/marker-shadow.png',
                iconSize: [25, 41],
                iconAnchor: [12, 41],
                popupAnchor: [1, -34],
                shadowSize: [41, 41]
            });
        }
    </script>
{% endblock %}